//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2007, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+
#property copyright "strategybuilderfx.com - modified by bluto to use typical price (HLC/3)"
#property link "finger"
//----
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Magenta
#property indicator_width1 3
#property indicator_level1 70
#property indicator_level2 30
#property indicator_level3 50
#property indicator_maximum 100
#property indicator_minimum 0
//---- input parameters
extern int Len=14; //---- buffers
double rsx[];
//---- constants ------------------------------------------------------------------------------+
#define ArrowSignature        "TJ_arrow"
#define ArrowSignature_50     "TJ_arrow_50"
#define ArrowWidth            5
#define ArrowWidth_50         5

//---- external parameters --------------------------------------------------------------------+
extern bool   UseAlertsAtLevel_50             = true;  // true = generate alerts at crossing line and 50
extern bool   UseAlertsAtLevel_User           = false;  // true = generate alerts at crossing line and Alert_BuyLevel/Alert_SellLevel
extern double Alert_BuyLevel                  = 30;    // level for generate Buy-alert; for generate Sell-alert use level = 100 - Alert_BuyLevel
extern bool   ArrowAlert                      = true;  // true = draw arrow on chart at crossing line and 0
extern color  Arrow_Color_Buy                 = LimeGreen; // color of Buy-arrow
extern color  Arrow_Color_Sell                = Red;   // color of Sell-arrow
extern color  Arrow_Color_Buy_50              = OrangeRed; // color of Buy-arrow
extern color  Arrow_Color_Sell_50             = OrangeRed; // color of Sell-arrow
extern double Arrow_OffsetPips                = 10;    // offset (in pips) arrow from peak of bar
extern bool   EmailAlert                      = false; // true = send e-mail at crossing line and level
extern bool   PopUpAlert                      = true;  // true = PopUp-message at crossing line and level
extern bool   SoundAlert                      = false; // true = play sound-file at crossing line and level
extern string SoundFile                       = "Junk.wav"; // name of sound-file (for option SoundAlert)
extern bool   AlertInTradeTime                = false; // true = generate alerts only in during TradeTime
extern int    StartTradeHour                  = 0;     // start hour (time of the MetaTrader)
extern int    StartTradeMinute                = 0;     // start minute
extern int    FinishTradeHour                 = 24;    // end hour (time of the MetaTrader)
extern int    FinishTradeMinute               = 0;     // end minute

//---- buffers --------------------------------------------------------------------------------+
static double   MainLine[];

//---- global variables -----------------------------------------------------------------------+
static int      gi_76 = 16;
static double   point;
static double   average_period;
static datetime bartime_alert_buy;
static datetime bartime_alert_sell;
static datetime bartime_alert_buy_50;
static datetime bartime_alert_sell_50;
static double   Alert_SellLevel;
static string   str_timeframe;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int init() 
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,rsx);
   IndicatorShortName("TurboJRSX");
   //---- set a levels of indicator -----------------------------------------------------------+
   SetLevelStyle(STYLE_DOT,0,Red);
   SetLevelValue(0,Alert_BuyLevel);
   SetLevelValue(1,100 - Alert_BuyLevel);
   SetLevelValue(2,50);
   //---- initialization constants and variables ----------------------------------------------+
   if(Digits < 3) point = 0.01;
   else point = 0.0001;
   Alert_SellLevel = 100 - Alert_BuyLevel;
   str_timeframe = TimeFrameToStr(Period());
   return (0);
}

//---------------------------------------------------------------------------------------------+
//---- deinitialization of indicator ----------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int deinit()
  {
   if(ArrowAlert)
     {
      DeleteObjects(ArrowSignature);
      DeleteObjects(ArrowSignature_50);
     }
   //---- finish of deinitialization ----------------------------------------------------------+
   return(0);
  }

int start()
  {
   double f88, f90;
   double f0, v4, v8, vC, v10, v14, v18, v20;
   double f8, f10, f18, f20, f28, f30, f38, f48, v1C;
   double f50, f58, f60, f68, f70, f78, f80, f40;
   //int counted_bars = IndicatorCounted(),limit,shift;
   //if (counted_bars<0) return(-1);
   //if (counted_bars>0) counted_bars--;
   double limit=Bars-(Len)-1;
   //if(counted_bars>Len) limit=Bars-counted_bars-1;
     for(int shift=limit;shift>=0;shift--) 
     {
        if (f90==0.0) 
        {
         f90=1.0;
         f0=0.0;
         if (Len-1>=5) f88=Len-1.0; else f88=5.0;
         //      f8 = 100.0*(Close[shift]);
         // 
         //      Modified for median price
         //
         f8=100.0*((High[shift]+Low[shift]+Close[shift])/3);
         f18=3.0/(Len + 2.0);
         f20=1.0 - f18;
         }
          else
         {
         if (f88<=f90) f90=f88 + 1; else f90=f90 + 1;
         f10=f8;
         //      f8 = 100*Close[shift];
         f8=100.0*((High[shift]+Low[shift]+Close[shift])/3);
         v8=f8 - f10;
         f28=f20 * f28 + f18 * v8;
         f30=f18 * f28 + f20 * f30;
         vC=f28 * 1.5 - f30 * 0.5;
         f38=f20 * f38 + f18 * vC;
         f40=f18 * f38 + f20 * f40;
         v10=f38 * 1.5 - f40 * 0.5;
         f48=f20 * f48 + f18 * v10;
         f50=f18 * f48 + f20 * f50;
         v14=f48 * 1.5 - f50 * 0.5;
         f58=f20 * f58 + f18 * MathAbs(v8);
         f60=f18 * f58 + f20 * f60;
         v18=f58 * 1.5 - f60 * 0.5;
         f68=f20 * f68 + f18 * v18;
         f70=f18 * f68 + f20 * f70;
         v1C=f68 * 1.5 - f70 * 0.5;
         f78=f20 * f78 + f18 * v1C;
         f80=f18 * f78 + f20 * f80;
         v20=f78 * 1.5 - f80 * 0.5;
//----
         if ((f88>=f90) && (f8!=f10)) f0=1.0;
         if ((f88==f90) && (f0==0.0)) f90=0.0;
        }
        if ((f88 < f90) && (v20 > 0.0000000001)) 
        {
         v4=(v14/v20 + 1.0) * 50.0;
         if (v4 > 100.0) v4=100.0;
         if (v4 < 0.0) v4=0.0;
         }
          else 
         {
         v4=50.0;
        }
      rsx[shift]=v4;
     }
//---- alerts at crossing ------------------------------------------------------------------+
   if(ArrowAlert || SoundAlert || EmailAlert || PopUpAlert) GenerateAlerts();
   //---- finish of iteration -----------------------------------------------------------------+
   return(0);
}

//---------------------------------------------------------------------------------------------+
//---- GenerateAlerts -------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void GenerateAlerts()
  {
   if(AlertInTradeTime) if(!IsTradeTime(TimeCurrent())) return;
   datetime cur_bartime_h1 = iTime(NULL,PERIOD_H1,0);
   if(UseAlertsAtLevel_User)
     {
      if(MainLine[1] < Alert_BuyLevel && MainLine[0] > Alert_BuyLevel)
        {
         if(bartime_alert_buy != cur_bartime_h1)
           {
            bartime_alert_buy = cur_bartime_h1;
            if(ArrowAlert) CreateObjectArrow(StringConcatenate(ArrowSignature," Buy ",TimeToStr(Time[0])),Time[0],NormalizeDouble(Low[0] - Arrow_OffsetPips*point,Digits),SYMBOL_ARROWUP,Arrow_Color_Buy,ArrowWidth);
            if(SoundAlert) PlaySound(SoundFile);
            if(EmailAlert)
              {
               string alert_message = StringConcatenate("TurboJRSXLevel alert: Buy ",Symbol()," ",str_timeframe);
               SendMail(StringConcatenate("Alert from indicator \"TurboJRSXalert\": ",alert_message),alert_message);
              }
            if(PopUpAlert)
              {
               alert_message = StringConcatenate("TurboJRSXLevel alert: Buy ",Symbol()," ",str_timeframe);
               Alert(alert_message);
              }
           }
        }
      if(MainLine[1] > Alert_SellLevel && MainLine[0] < Alert_SellLevel)
        {
         if(bartime_alert_sell != cur_bartime_h1)
           {
            bartime_alert_sell = cur_bartime_h1;
            if(ArrowAlert) CreateObjectArrow(StringConcatenate(ArrowSignature," Sell ",TimeToStr(Time[0])),Time[0],NormalizeDouble(High[0] + Arrow_OffsetPips*point,Digits),SYMBOL_ARROWDOWN,Arrow_Color_Sell,ArrowWidth);
            if(SoundAlert) PlaySound(SoundFile);
            if(EmailAlert)
              {
               alert_message = StringConcatenate("TurboJRSXLevel alert: Sell ",Symbol()," ",str_timeframe);
               SendMail(StringConcatenate("Alert from indicator \"TurboJRSXalert\": ",alert_message),alert_message);
              }
            if(PopUpAlert)
              {
               alert_message = StringConcatenate("TurboJRSXLevel alert: Sell ",Symbol()," ",str_timeframe);
               Alert(alert_message);
              }
           }
        }
     }
   if(UseAlertsAtLevel_50)
     {
      if(MainLine[1] < 50 && MainLine[0] > 50)
        {
         if(bartime_alert_buy_50 != cur_bartime_h1)
           {
            bartime_alert_buy_50 = cur_bartime_h1;
            if(ArrowAlert) CreateObjectArrow(StringConcatenate(ArrowSignature_50," Buy ",TimeToStr(Time[0])),Time[0],NormalizeDouble(Low[0] - Arrow_OffsetPips*point,Digits),SYMBOL_ARROWUP,Arrow_Color_Buy_50,ArrowWidth_50);
            if(SoundAlert) PlaySound(SoundFile);
            if(EmailAlert)
              {
               alert_message = StringConcatenate("TurboJRSX 50 alert: Buy ",Symbol()," ",str_timeframe);
               SendMail(StringConcatenate("Alert from indicator \"TurboJRSXalert\": ",alert_message),alert_message);
              }
            if(PopUpAlert)
              {
               alert_message = StringConcatenate("TurboJRSX 50 alert: Buy ",Symbol()," ",str_timeframe);
               Alert(alert_message);
              }
           }
        }
      if(MainLine[1] > 50 && MainLine[0] < 50)
        {
         if(bartime_alert_sell_50 != cur_bartime_h1)
           {
            bartime_alert_sell_50 = cur_bartime_h1;
            if(ArrowAlert) CreateObjectArrow(StringConcatenate(ArrowSignature_50," Sell ",TimeToStr(Time[0])),Time[0],NormalizeDouble(High[0] + Arrow_OffsetPips*point,Digits),SYMBOL_ARROWDOWN,Arrow_Color_Sell_50,ArrowWidth_50);
            if(SoundAlert) PlaySound(SoundFile);
            if(EmailAlert)
              {
               alert_message = StringConcatenate("TurboJRSX 50 alert: Sell ",Symbol()," ",str_timeframe);
               SendMail(StringConcatenate("Alert from indicator \"TurboJRSXalert\": ",alert_message),alert_message);
              }
            if(PopUpAlert)
              {
               alert_message = StringConcatenate("TurboJRSX 50 alert: Sell ",Symbol()," ",str_timeframe);
               Alert(alert_message);
              }
           }
        }
     }
  }


bool IsTradeTime(datetime c_time)
  {
   int cur_hour = TimeHour(c_time);
   int cur_min = TimeMinute(c_time);
   if(StartTradeHour == FinishTradeHour && StartTradeMinute == FinishTradeMinute) return(true);
   if(FinishTradeMinute == 0)
     {
      if(FinishTradeHour == 0) int fth = 23;
      else fth = FinishTradeHour - 1;
      int ftm = 59;      
     }
   else
     {
      fth = FinishTradeHour;
      ftm = FinishTradeMinute - 1;      
     }
   if(StartTradeHour == fth)
     {
      if(StartTradeMinute == ftm) return(true);
      if(StartTradeMinute < ftm)
        {
         if(cur_hour != StartTradeHour) return(false);
         if(cur_min < StartTradeMinute || cur_min > ftm) return(false);
         return(true);
        }
      if(StartTradeMinute > ftm)
        {
         if(cur_hour == StartTradeHour)
           {
            if(cur_min < StartTradeMinute && cur_min > ftm) return(false);
           }
         return(true);
        }
     }
   if(StartTradeHour < fth)
     {
      if(cur_hour < StartTradeHour || cur_hour > fth) return(false);
      if(cur_hour == StartTradeHour && cur_min < StartTradeMinute) return(false);
      if(cur_hour == fth && cur_min > ftm) return(false);
      return(true);
     }
   if(StartTradeHour > fth)
     {
      if(cur_hour < StartTradeHour && cur_hour > fth) return(false);
      if(cur_hour == StartTradeHour && cur_min < StartTradeMinute) return(false);
      if(cur_hour == fth && cur_min > ftm) return(false);
      return(true);
     }
   return(true);
  }


void DeleteObjects(string obj_name_signature, int obj_type=-1)
  {
   int obj_total = ObjectsTotal() - 1;
   for(int i=obj_total; i>=0; i--)
     {
      string obj_name = ObjectName(i);
      if(obj_type >= 0 && ObjectType(obj_name) != obj_type) continue;
      if(StringFind(obj_name,obj_name_signature,0) != 0) continue;
      ObjectDelete(obj_name);
     }
  }


void CreateObjectArrow(string obj_name, datetime obj_time1, double obj_price1, int obg_arrowcode, color obj_color, int obj_width, int obj_window = 0)
  {
   if(ObjectFind(obj_name) < 0) ObjectCreate(obj_name,OBJ_ARROW,obj_window,obj_time1,obj_price1);
   else
     {
      if(ObjectGet(obj_name,OBJPROP_TIME1) != obj_time1 || NormalizeDouble(ObjectGet(obj_name,OBJPROP_PRICE1),Digits) != obj_price1)
        {
         ObjectMove(obj_name,0,obj_time1,obj_price1);
        }
     }
   ObjectSet(obj_name,OBJPROP_ARROWCODE,obg_arrowcode);
   ObjectSet(obj_name,OBJPROP_WIDTH,obj_width);
   ObjectSet(obj_name,OBJPROP_COLOR,obj_color);
  }


string TimeFrameToStr(int period)
  {
   switch(period)
     {
      case     1: string TimeFrameStr = "M1";          break;
      case     5:        TimeFrameStr = "M5";          break;
      case    15:        TimeFrameStr = "M15";         break;
      case    30:        TimeFrameStr = "M30";         break;
      case    60:        TimeFrameStr = "H1";          break;
      case   240:        TimeFrameStr = "H4";          break;
      case  1440:        TimeFrameStr = "D1";          break;
      case 10080:        TimeFrameStr = "W1";          break;
      case 43200:        TimeFrameStr = "MN1";         break;
      default:           TimeFrameStr = TimeFrameToStr(Period());
     }
   return(TimeFrameStr);
  }
  
//-------------------------------------------------------------------------